Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -3898,106 +3812,185 @@
        !$ACC PRESENT(sums_salsa_ws_l)
        DO  i = nxl, nxr
-
+          DO  j = nys, nyn
+!
+!--          Used local modified copy of nzb_max (used to degrade order of
+!--          discretization) at non-cyclic boundaries. Modify only at relevant points
+!--          instead of the entire subdomain. This should lead to better
+!--          load balance between boundary and non-boundary PEs.
+             IF( non_cyclic_l  .AND.  i <= nxl + 2  .OR.                       &
+                 non_cyclic_r  .AND.  i >= nxr - 2  .OR.                       &
+                 non_cyclic_s  .AND.  j <= nys + 2  .OR.                       &
+                 non_cyclic_n  .AND.  j >= nyn - 2 )  THEN
+                nzb_max_l = nzt
+             ELSE
+                nzb_max_l = nzb_max
+             END IF
 #ifndef _OPENACC
-          j = nys
-          DO  k = nzb+1, nzb_max_l
-
-             ibit5 = REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )
-             ibit4 = REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )
-             ibit3 = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
-
-             v_comp               = v(k,j,i) - v_gtrans + v_stokes_zu(k)
-             swap_flux_y_local(k) = v_comp * (                                &
-                                             ( 37.0_wp * ibit5 * adv_sca_5    &
-                                          +     7.0_wp * ibit4 * adv_sca_3    &
-                                          +              ibit3 * adv_sca_1    &
-                                             ) *                              &
-                                         ( sk(k,j,i)  + sk(k,j-1,i)     )     &
-                                       -     (  8.0_wp * ibit5 * adv_sca_5    &
-                                          +              ibit4 * adv_sca_3    &
-                                              ) *                             &
-                                         ( sk(k,j+1,i) + sk(k,j-2,i)    )     &
-                                      +      (           ibit5 * adv_sca_5    &
-                                             ) *                              &
-                                        ( sk(k,j+2,i) + sk(k,j-3,i)     )     &
-                                             )
-
-             swap_diss_y_local(k) = -ABS( v_comp ) * (                        &
-                                             ( 10.0_wp * ibit5 * adv_sca_5    &
-                                          +     3.0_wp * ibit4 * adv_sca_3    &
-                                          +              ibit3 * adv_sca_1    &
-                                             ) *                              &
-                                          ( sk(k,j,i)   - sk(k,j-1,i)    )    &
-                                      -      (  5.0_wp * ibit5 * adv_sca_5    &
-                                          +              ibit4 * adv_sca_3    &
-                                             ) *                              &
-                                          ( sk(k,j+1,i) - sk(k,j-2,i)    )    &
-                                      +      (           ibit5 * adv_sca_5    &
-                                             ) *                              &
-                                          ( sk(k,j+2,i) - sk(k,j-3,i)    )    &
-                                                     )
-
-          ENDDO
-!
-!--       Above to the top of the highest topography. No degradation necessary.
-          DO  k = nzb_max_l+1, nzt
-
-             v_comp               = v(k,j,i) - v_gtrans + v_stokes_zu(k)
-             swap_flux_y_local(k) = v_comp * (                               &
-                                    37.0_wp * ( sk(k,j,i)   + sk(k,j-1,i) )  &
-                                  -  8.0_wp * ( sk(k,j+1,i) + sk(k,j-2,i) )  &
-                                  +           ( sk(k,j+2,i) + sk(k,j-3,i) )  &
-                                             ) * adv_sca_5
-             swap_diss_y_local(k) = -ABS( v_comp ) * (                       &
-                                    10.0_wp * ( sk(k,j,i)   - sk(k,j-1,i) )  &
-                                  -  5.0_wp * ( sk(k,j+1,i) - sk(k,j-2,i) )  &
-                                  +             sk(k,j+2,i) - sk(k,j-3,i)    &
+!
+!--          Compute leftside fluxes of the respective PE bounds.
+             IF ( i == nxl )  THEN
+
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit2 = REAL( IBITS(advc_flag(k,j,i-1),2,1), KIND = wp )
+                   ibit1 = REAL( IBITS(advc_flag(k,j,i-1),1,1), KIND = wp )
+                   ibit0 = REAL( IBITS(advc_flag(k,j,i-1),0,1), KIND = wp )
+
+                   u_comp                    = u(k,j,i) - u_gtrans + u_stokes_zu(k)
+                   swap_flux_x_local(k,j,tn) = u_comp * (                      &
+                                               ( 37.0_wp * ibit2 * adv_sca_5   &
+                                            +     7.0_wp * ibit1 * adv_sca_3   &
+                                            +              ibit0 * adv_sca_1   &
+                                               ) *                             &
+                                            ( sk(k,j,i)   + sk(k,j,i-1)    )   &
+                                        -      (  8.0_wp * ibit2 * adv_sca_5   &
+                                            +              ibit1 * adv_sca_3   &
+                                               ) *                             &
+                                            ( sk(k,j,i+1) + sk(k,j,i-2)    )   &
+                                        +      (           ibit2 * adv_sca_5   &
+                                               ) *                             &
+                                               ( sk(k,j,i+2) + sk(k,j,i-3)    )&
+                                                        )
+
+                   swap_diss_x_local(k,j,tn) = -ABS( u_comp ) * (              &
+                                                ( 10.0_wp * ibit2 * adv_sca_5  &
+                                             +     3.0_wp * ibit1 * adv_sca_3  &
+                                             +              ibit0 * adv_sca_1  &
+                                                ) *                            &
+                                             ( sk(k,j,i)   - sk(k,j,i-1)    )  &
+                                         -      (  5.0_wp * ibit2 * adv_sca_5  &
+                                             +              ibit1 * adv_sca_3  &
+                                                ) *                            &
+                                             ( sk(k,j,i+1) - sk(k,j,i-2)    )  &
+                                         +      (           ibit2 * adv_sca_5  &
+                                                ) *                            &
+                                             ( sk(k,j,i+2) - sk(k,j,i-3)    )  &
+                                                                )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt
+
+                   u_comp                    = u(k,j,i) - u_gtrans + u_stokes_zu(k)
+                   swap_flux_x_local(k,j,tn) = u_comp * (                      &
+                                        37.0_wp * ( sk(k,j,i)   + sk(k,j,i-1) )&
+                                      -  8.0_wp * ( sk(k,j,i+1) + sk(k,j,i-2) )&
+                                      +           ( sk(k,j,i+2) + sk(k,j,i-3) )&
+                                                        ) * adv_sca_5
+
+                   swap_diss_x_local(k,j,tn) = -ABS( u_comp ) * (              &
+                                        10.0_wp * ( sk(k,j,i)   - sk(k,j,i-1) )&
+                                      -  5.0_wp * ( sk(k,j,i+1) - sk(k,j,i-2) )&
+                                      +           ( sk(k,j,i+2) - sk(k,j,i-3) )&
+                                                                ) * adv_sca_5
+
+                ENDDO
+
+             ENDIF
+!
+!--          Compute southside fluxes of the respective PE bounds.
+             IF ( j == nys )  THEN
+!
+!--             Up to the top of the highest topography.
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit5 = REAL( IBITS(advc_flag(k,j-1,i),5,1), KIND = wp )
+                   ibit4 = REAL( IBITS(advc_flag(k,j-1,i),4,1), KIND = wp )
+                   ibit3 = REAL( IBITS(advc_flag(k,j-1,i),3,1), KIND = wp )
+
+                   v_comp                  = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                   swap_flux_y_local(k,tn) = v_comp *         (                &
+                                                ( 37.0_wp * ibit5 * adv_sca_5  &
+                                             +     7.0_wp * ibit4 * adv_sca_3  &
+                                             +              ibit3 * adv_sca_1  &
+                                                ) *                            &
+                                            ( sk(k,j,i)  + sk(k,j-1,i)     )   &
+                                          -     (  8.0_wp * ibit5 * adv_sca_5  &
+                                             +              ibit4 * adv_sca_3  &
+                                                 ) *                           &
+                                            ( sk(k,j+1,i) + sk(k,j-2,i)    )   &
+                                          +     (           ibit5 * adv_sca_5  &
+                                                ) *                            &
+                                            ( sk(k,j+2,i) + sk(k,j-3,i)    )   &
+                                                              )
+
+                   swap_diss_y_local(k,tn) = -ABS( v_comp ) * (                &
+                                                ( 10.0_wp * ibit5 * adv_sca_5  &
+                                             +     3.0_wp * ibit4 * adv_sca_3  &
+                                             +              ibit3 * adv_sca_1  &
+                                                ) *                            &
+                                             ( sk(k,j,i)   - sk(k,j-1,i)  )    &
+                                         -      (  5.0_wp * ibit5 * adv_sca_5  &
+                                             +              ibit4 * adv_sca_3  &
+                                             ) *                               &
+                                             ( sk(k,j+1,i) - sk(k,j-2,i)  )    &
+                                         +      (           ibit5 * adv_sca_5  &
+                                                ) *                            &
+                                             ( sk(k,j+2,i) - sk(k,j-3,i)  )    &
+                                                              )
+
+                ENDDO
+!
+!--             Above to the top of the highest topography. No degradation necessary.
+                DO  k = nzb_max_l+1, nzt
+
+                   v_comp                  = v(k,j,i) - v_gtrans + v_stokes_zu(k)
+                   swap_flux_y_local(k,tn) = v_comp * (                        &
+                                     37.0_wp * ( sk(k,j,i)   + sk(k,j-1,i) )   &
+                                   -  8.0_wp * ( sk(k,j+1,i) + sk(k,j-2,i) )   &
+                                   +           ( sk(k,j+2,i) + sk(k,j-3,i) )   &
                                                       ) * adv_sca_5
-
-          ENDDO
+                   swap_diss_y_local(k,tn) = -ABS( v_comp ) * (                &
+                                     10.0_wp * ( sk(k,j,i)   - sk(k,j-1,i) )   &
+                                   -  5.0_wp * ( sk(k,j+1,i) - sk(k,j-2,i) )   &
+                                   +             sk(k,j+2,i) - sk(k,j-3,i)     &
+                                                         ) * adv_sca_5
+
+                ENDDO
+
+             ENDIF
 #endif
-
-          DO  j = nys, nyn
-
-             flux_d    = 0.0_wp
-             diss_d    = 0.0_wp
-
+!
+!--          Now compute the fluxes and tendency terms for the horizontal and
+!--          vertical parts up to the top of the highest topography.
              DO  k = nzb+1, nzb_max_l
-
+!
+!--             Note: It is faster to conduct all multiplications explicitly, e.g.
+!--             * adv_sca_5 ... than to determine a factor and multiplicate the
+!--             flux at the end.
                 ibit2 = REAL( IBITS(advc_flag(k,j,i),2,1), KIND = wp )
                 ibit1 = REAL( IBITS(advc_flag(k,j,i),1,1), KIND = wp )
                 ibit0 = REAL( IBITS(advc_flag(k,j,i),0,1), KIND = wp )
 
-                u_comp = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
-                flux_r = u_comp * (                                           &
-                          ( 37.0_wp * ibit2 * adv_sca_5                       &
-                      +      7.0_wp * ibit1 * adv_sca_3                       &
-                      +               ibit0 * adv_sca_1                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+1) + sk(k,j,i)   )                    &
-                   -      (  8.0_wp * ibit2 * adv_sca_5                       &
-                       +              ibit1 * adv_sca_3                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+2) + sk(k,j,i-1) )                    &
-                   +      (           ibit2 * adv_sca_5                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+3) + sk(k,j,i-2) )                    &
+                u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
+                flux_r(k) = u_comp * (                                         &
+                           ( 37.0_wp * ibit2 * adv_sca_5                       &
+                        +     7.0_wp * ibit1 * adv_sca_3                       &
+                        +              ibit0 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+1) + sk(k,j,i)   )               &
+                    -      (  8.0_wp * ibit2 * adv_sca_5                       &
+                        +              ibit1 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+2) + sk(k,j,i-1) )               &
+                    +      (           ibit2 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+3) + sk(k,j,i-2) )               &
                                      )
 
-                diss_r = -ABS( u_comp ) * (                                   &
-                          ( 10.0_wp * ibit2 * adv_sca_5                       &
-                       +     3.0_wp * ibit1 * adv_sca_3                       &
-                       +              ibit0 * adv_sca_1                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+1) - sk(k,j,i)   )                    &
-                   -      (  5.0_wp * ibit2 * adv_sca_5                       &
-                       +              ibit1 * adv_sca_3                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+2) - sk(k,j,i-1) )                    &
-                   +      (           ibit2 * adv_sca_5                       &
-                          ) *                                                 &
-                             ( sk(k,j,i+3) - sk(k,j,i-2) )                    &
+                diss_r(k) = -ABS( u_comp ) * (                                 &
+                           ( 10.0_wp * ibit2 * adv_sca_5                       &
+                        +     3.0_wp * ibit1 * adv_sca_3                       &
+                        +              ibit0 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+1) - sk(k,j,i)  )                &
+                    -      (  5.0_wp * ibit2 * adv_sca_5                       &
+                        +              ibit1 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+2) - sk(k,j,i-1) )               &
+                    +      (           ibit2 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k,j,i+3) - sk(k,j,i-2) )               &
                                              )
-
 #ifdef _OPENACC
 !
@@ -4008,73 +4001,68 @@
 
                 u_comp_l = u(k,j,i) - u_gtrans + u_stokes_zu(k)
-                flux_l = u_comp_l * (                                         &
-                                             ( 37.0_wp * ibit2_l * adv_sca_5  &
-                                          +     7.0_wp * ibit1_l * adv_sca_3  &
-                                          +              ibit0_l * adv_sca_1  &
-                                             ) *                              &
-                                          ( sk(k,j,i)   + sk(k,j,i-1)    )    &
-                                      -      (  8.0_wp * ibit2_l * adv_sca_5  &
-                                          +              ibit1_l * adv_sca_3  &
-                                             ) *                              &
-                                          ( sk(k,j,i+1) + sk(k,j,i-2)    )    &
-                                      +      (           ibit2_l * adv_sca_5  & 
-                                             ) *                              &
-                                          ( sk(k,j,i+2) + sk(k,j,i-3)    )    &
-                                               )
-
-                 diss_l = -ABS( u_comp_l ) * (                                &
-                                             ( 10.0_wp * ibit2_l * adv_sca_5  &
-                                          +     3.0_wp * ibit1_l * adv_sca_3  &
-                                          +              ibit0_l * adv_sca_1  &
-                                             ) *                              &
-                                          ( sk(k,j,i)   - sk(k,j,i-1) )       &
-                                      -      (  5.0_wp * ibit2_l * adv_sca_5  &
-                                          +              ibit1_l * adv_sca_3  &
-                                             ) *                              &
-                                         ( sk(k,j,i+1) - sk(k,j,i-2)  )       &
-                                      +      (           ibit2_l * adv_sca_5  &
-                                             ) *                              &
-                                          ( sk(k,j,i+2) - sk(k,j,i-3) )       &
-                                                        )
-#else
-                flux_l = swap_flux_x_local(k,j)
-                diss_l = swap_diss_x_local(k,j)
+                swap_flux_x_local(k,j,tn) = u_comp_l * (                       &
+                                             ( 37.0_wp * ibit2_l * adv_sca_5   &
+                                          +     7.0_wp * ibit1_l * adv_sca_3   &
+                                          +              ibit0_l * adv_sca_1   &
+                                             ) *                               &
+                                          ( sk(k,j,i)   + sk(k,j,i-1)    )     &
+                                      -      (  8.0_wp * ibit2_l * adv_sca_5   &
+                                          +              ibit1_l * adv_sca_3   &
+                                             ) *                               &
+                                          ( sk(k,j,i+1) + sk(k,j,i-2)    )     &
+                                      +      (           ibit2_l * adv_sca_5   &
+                                             ) *                               &
+                                          ( sk(k,j,i+2) + sk(k,j,i-3)    )     &
+                                                       )
+
+                swap_diss_x_local(k,j,tn) = -ABS( u_comp_l ) * (               &
+                                            ( 10.0_wp * ibit2_l * adv_sca_5    &
+                                         +     3.0_wp * ibit1_l * adv_sca_3    &
+                                         +              ibit0_l * adv_sca_1    &
+                                            ) *                                &
+                                         ( sk(k,j,i)   - sk(k,j,i-1) )         &
+                                     -      (  5.0_wp * ibit2_l * adv_sca_5    &
+                                         +              ibit1_l * adv_sca_3    &
+                                            ) *                                &
+                                        ( sk(k,j,i+1) - sk(k,j,i-2)  )         &
+                                     +      (           ibit2_l * adv_sca_5    &
+                                            ) *                                &
+                                         ( sk(k,j,i+2) - sk(k,j,i-3) )         &
+                                                               )
 #endif
-
                 ibit5 = REAL( IBITS(advc_flag(k,j,i),5,1), KIND = wp )
                 ibit4 = REAL( IBITS(advc_flag(k,j,i),4,1), KIND = wp )
                 ibit3 = REAL( IBITS(advc_flag(k,j,i),3,1), KIND = wp )
 
-                v_comp = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
-                flux_n = v_comp * (                                           &
-                          ( 37.0_wp * ibit5 * adv_sca_5                       &
-                       +     7.0_wp * ibit4 * adv_sca_3                       &
-                       +              ibit3 * adv_sca_1                       &
-                          ) *                                                 &
-                             ( sk(k,j+1,i) + sk(k,j,i)   )                    &
-                   -      (  8.0_wp * ibit5 * adv_sca_5                       &
-                       +              ibit4 * adv_sca_3                       &
-                          ) *                                                 &
-                             ( sk(k,j+2,i) + sk(k,j-1,i) )                    &
-                   +      (           ibit5 * adv_sca_5                       &
-                          ) *                                                 &
-                             ( sk(k,j+3,i) + sk(k,j-2,i) )                    &
+                v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
+                flux_n(k) = v_comp * (                                         &
+                           ( 37.0_wp * ibit5 * adv_sca_5                       &
+                        +     7.0_wp * ibit4 * adv_sca_3                       &
+                        +              ibit3 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k,j+1,i) + sk(k,j,i)   )               &
+                    -      (  8.0_wp * ibit5 * adv_sca_5                       &
+                        +              ibit4 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k,j+2,i) + sk(k,j-1,i) )               &
+                    +      (           ibit5 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k,j+3,i) + sk(k,j-2,i) )               &
                                      )
 
-                diss_n = -ABS( v_comp ) * (                                   &
-                          ( 10.0_wp * ibit5 * adv_sca_5                       &
-                       +     3.0_wp * ibit4 * adv_sca_3                       &
-                       +              ibit3 * adv_sca_1                       &
-                          ) *                                                 &
-                             ( sk(k,j+1,i) - sk(k,j,i)    )                   &
-                   -      (  5.0_wp * ibit5 * adv_sca_5                       &
-                       +              ibit4 * adv_sca_3                       &
-                          ) *                                                 &
-                             ( sk(k,j+2,i) - sk(k,j-1,i)  )                   &
-                   +      (           ibit5 * adv_sca_5                       &
-                          ) *                                                 &
-                             ( sk(k,j+3,i) - sk(k,j-2,i) )                    &
+                diss_n(k) = -ABS( v_comp ) * (                                 &
+                           ( 10.0_wp * ibit5 * adv_sca_5                       &
+                        +     3.0_wp * ibit4 * adv_sca_3                       &
+                        +              ibit3 * adv_sca_1                       &
+                           ) *                                                 &
+                                   ( sk(k,j+1,i) - sk(k,j,i)   )               &
+                    -      (  5.0_wp * ibit5 * adv_sca_5                       &
+                        +              ibit4 * adv_sca_3                       &
+                           ) *                                                 &
+                                   ( sk(k,j+2,i) - sk(k,j-1,i) )               &
+                    +      (           ibit5 * adv_sca_5                       &
+                           ) *                                                 &
+                                   ( sk(k,j+3,i) - sk(k,j-2,i) )               &
                                              )
-
 #ifdef _OPENACC
 !
